/* -----------------------------------------------------------------------------
	Nbp֐
	t@C  : ayu.as
			: hakuhin (c) 2006/11/12
	
			: p֐
 ----------------------------------------------------------------------------- */

AYU_WIDTH  = 34;
AYU_HEIGHT = 54;
AYU_RADIUS = AYU_WIDTH / 2;
AYU_MOVE_ADD	= 0.1;
AYU_MOVE_MAX	= 1.0;
AYU_JUMP_POW	= 4;
AYU_G			=0.1;
AYU_PRESS_SPD	= 5;
AYU_PRESS_G		= 0.5;
AYU_PRESS_POW	= 6;
AYU_PRESS_MAX	= 10;
AYU_MOVE_SPD      = 1.0;


AyuCollisionRect = {
	x : -AYU_RADIUS + 4,
	y : -AYU_HEIGHT + 2,
	w :  AYU_WIDTH  - 8,
	h :  AYU_HEIGHT - 2
};


AYU_TASK = null;


AYU_FLG_ATTACK	 = 0x01;
AYU_FLG_STAY	 = 0x02;

/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function AyuTaskCreate(task,param){
	return TaskCreate(
		AyuInitalize,
		AyuExecute,
		AyuDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function AyuInitalize(obj,task,param){
	obj.task = AYU_TASK = task;
	obj.id = param.id;
	obj.pos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.dir = -1;
	obj.flg = 0;
	
	
	obj.spd = Vec2dCreate(0,0);
	
	if(!obj.depth){
		obj.depth = EnemyDepthGet();
	}

	if(!obj.mc){
	    obj.mc = _root.sprite.attachMovie("ayu","_" + obj.depth.depth, obj.depth.depth);
		AnmCmdInit(obj.mc);
		obj.mc.ANM_GOTO = "_stand";
	}

	var rect = {
		x : -AYU_RADIUS,
		y : -AYU_HEIGHT,
		w :  AYU_WIDTH,
		h :  AYU_HEIGHT
	};
	obj.hittest = {pos : obj.pos,rect: rect,func:AyuHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_BOSS);
	
	obj.fire_count = 0;

	obj.exec = AyuStayInit;
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function AyuExecute(obj){
	obj.exec(obj);	// s

	if(StageEndPos(obj)){
		obj.dir *= -1;
		obj.spd.x *= -1;
	}

	if(obj.flg & AYU_FLG_ATTACK){
		if(++obj.fire_count > 180){
			obj.fire_count = 0;
			var pos = Vec2dCreate(obj.pos.x + obj.dir * 20,obj.pos.y - 40);
			var spd = Vec2dCreate(obj.dir * 2,-1);
			FireWaveOriginTaskCreate(obj.task,{pos:pos,spd:spd});
		}
	}

	AnmCmdPlay(obj.mc);
	obj.mc._xscale = obj.dir * 100;
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function AyuDelete(obj){
	AYU_TASK = null;

	if(obj.depth){
		FreeDepthPurge(obj.depth);
		obj.depth = null;
	}

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	if(obj.mc){
		obj.mc.removeMovieClip();
		obj.mc = null;
	}
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function AyuAttachScript(param,id,task){
	AyuTaskCreate(task,{
		pos : param.pos,
		id  : id
	});
}

/* --------------------------------------------------------------
	ҋ@
 -------------------------------------------------------------- */
function AyuStayInit(obj){
	obj.mc.ANM_GOTO = "_stand";

	obj.exec = AyuStayExec;
	AyuStayExec(obj);
}


/* --------------------------------------------------------------
	ҋ@s
 -------------------------------------------------------------- */
function AyuStayExec(obj){
	//vC[߂Â܂őҋ@
	var x = obj.pos.x - (ScrollData.pos.x + GAME_WIDTH_HALF);
	var y = obj.pos.y - (ScrollData.pos.y + GAME_HEIGHT_HALF);

	if((Math.abs(x) < GAME_WIDTH_HALF) && (Math.abs(y) < GAME_HEIGHT_HALF)){
		obj.exec = AyuSmileInit;
	}
}


/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function AyuSmileInit(obj){
	obj.mc.ANM_GOTO = "_smile";

	obj.count = 0;

	obj.exec = AyuSmileExec;
	AyuSmileExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function AyuSmileExec(obj){
	if(++ obj.count > 120){
		obj.flg |= AYU_FLG_ATTACK;
		obj.exec = AyuThinkInit;
	}
}


/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function AyuClushInit(obj){

	if(obj.depth){
		FreeDepthPurge(obj.depth);
	}
	// [x`FW
	obj.depth = EffectDepthGet();
	obj.mc.swapDepths(obj.depth.depth);
	obj.mc.ANM_GOTO = "_damage";


	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	obj.base = Vec2dClone(obj.pos);

	obj.count = 0;

	obj.exec = AyuClushExec;
	AyuClushExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function AyuClushExec(obj){

	d = obj.count / 15;
	if(d > 1)	d = 1;
	d = 1 - d;
	
	var v = Vec2dRandom(d * 10);
	
	obj.pos = Vec2dAdd(obj.base,v);
	
	
	if(++ obj.count > 30){
		obj.exec = AyuBlowInit;
	}

}

/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function AyuBlowInit(obj){
	obj.spd.y = -3;
	obj.spd.x = 0;
	obj.mc.ANM_GOTO = "_death";

	obj.count = 0;

	obj.exec = AyuBlowExec;
	AyuBlowExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function AyuBlowExec(obj){
	obj.spd.y += AYU_G;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	
	if(obj.count == 150){
		SePlay(SE_CANNON,obj.pos);
		StageSetShake(30,30);
	}

	if(++obj.count > 300){
		BlackFadeOutCreate(null , {func : NextEndingFunc , param : obj});
		return;
	}
}


function NextEndingFunc(obj){
	TaskDelete(STAGE_TASK);
	EndingCreate(null,null);
}


/* --------------------------------------------------------------
	vl
 -------------------------------------------------------------- */
function AyuThinkInit(obj){

	obj.mc.ANM_GOTO = "_stand";

	obj.exec = AyuThinkExec;
	AyuThinkExec(obj);
}

function AyuThinkExec(obj){

	obj.dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);
	
	if(!(obj.flg & AYU_FLG_STAY)){
		var type = Math.floor(Math.random() * 5);
		switch(type){
			case 0:	obj.exec = AyuRightMoveInit;	break;
			case 1:	obj.exec = AyuRightJumpInit;	break;
			case 2:	obj.exec = AyuLeftMoveInit;		break;
			case 3:	obj.exec = AyuLeftJumpInit;		break;
			case 4:	obj.exec = AyuPressInit;		break;
		}
	}
}


/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function AyuPressInit(obj){
	obj.exec = AyuPressExec;
	
	obj.spd.y -= AYU_PRESS_POW;
	obj.spd.x = (PLAYER_TASK.obj.pos.x - obj.pos.x) / 30;
	if(obj.spd.x < -AYU_PRESS_SPD)	obj.spd.x = -AYU_PRESS_SPD;
	if(obj.spd.x >  AYU_PRESS_SPD)	obj.spd.x =  AYU_PRESS_SPD;

	obj.count = 30;

	AyuPressExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function AyuPressExec(obj){
	AyuAttackCheck(obj);
	
	obj.dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);

	obj.spd.y += AYU_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
	}
	
	
	if(--obj.count < 0){
		obj.exec = AyuPressWaitInit;
	}
}

/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function AyuPressWaitInit(obj){
	obj.exec = AyuPressWaitExec;
	
	obj.spd.y = 0;
	obj.spd.x = 0;

	obj.count = 30;

	AyuPressWaitExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function AyuPressWaitExec(obj){
	AyuAttackCheck(obj);
	
	obj.dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);

	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
	}
	
	
	if(--obj.count < 0){
		obj.exec = AyuPressDownInit;
	}
}

/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function AyuPressDownInit(obj){
	obj.exec = AyuPressDownExec;
	
	obj.spd.y = 1;
	obj.spd.x = 0;

	obj.count = 10;

	AyuPressDownExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function AyuPressDownExec(obj){
	AyuAttackCheck(obj);

	obj.spd.y += AYU_PRESS_G;

	if(obj.spd.y > AYU_PRESS_MAX)
		obj.spd.y = AYU_PRESS_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
		obj.exec = AyuPressStanInit;
	}
}


function AyuPressStanInit(obj){
	obj.exec = AyuPressStanExec;
	
	obj.spd.y = 0;
	obj.spd.x = 0;

	obj.count = 60;
	StageSetShake(20,20);
	SePlay(SE_CANNON,obj.pos);

	// Helmet
	
	if(obj.flg & AYU_FLG_STAY){
	}else{
		var vec = Vec2dCreate(Math.random() * 200 + 80, 0);
		vec = WorldPosition(vec);
		if(vec.x > 840)	vec.x = 840;
		HelmetTaskCreate(STAGE_TASK,{pos : vec,id  : -1});
	}

	AyuPressStanExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function AyuPressStanExec(obj){
	AyuAttackCheck(obj);
	
	obj.dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);

	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
	}

	if(--obj.count < 0){
		obj.exec = AyuThinkInit;
	}
}

/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function AyuRightMoveInit(obj){
	obj.exec = AyuRightMoveExec;

	obj.count = Math.floor(Math.random() * 120) + 60;

	AyuRightMoveExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function AyuRightMoveExec(obj){
	AyuAttackCheck(obj);
	
	obj.dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);

	obj.spd.x -= AYU_MOVE_ADD;
	if(obj.spd.x <-AYU_MOVE_MAX)	obj.spd.x =-AYU_MOVE_MAX;

	obj.spd.y += AYU_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
	}
	
	
	if(--obj.count < 0){
		obj.exec = AyuThinkInit;
	}
}

/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function AyuLeftMoveInit(obj){
	obj.exec = AyuLeftMoveExec;

	obj.count = Math.floor(Math.random() * 120) + 60;

	AyuLeftMoveExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function AyuLeftMoveExec(obj){
	AyuAttackCheck(obj);

	obj.dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);

	obj.spd.x += AYU_MOVE_ADD;
	if(obj.spd.x > AYU_MOVE_MAX)	obj.spd.x = AYU_MOVE_MAX;

	obj.spd.y += AYU_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
	}
	
	
	if(--obj.count < 0){
		obj.exec = AyuThinkInit;
	}
}

/* --------------------------------------------------------------
	GWv
 -------------------------------------------------------------- */
function AyuRightJumpInit(obj){
	obj.exec = AyuRightJumpExec;

	obj.spd.x = AYU_MOVE_MAX;
	obj.spd.y = -AYU_JUMP_POW;

	AyuRightJumpExec(obj);
}


/* --------------------------------------------------------------
	GWvs
 -------------------------------------------------------------- */
function AyuRightJumpExec(obj){
	AyuAttackCheck(obj);

	obj.spd.y += AYU_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
		obj.exec = AyuJumpStanInit;
	}
}

/* --------------------------------------------------------------
	GWv
 -------------------------------------------------------------- */
function AyuLeftJumpInit(obj){
	obj.exec = AyuLeftJumpExec;
	
	obj.spd.x = -AYU_MOVE_MAX;
	obj.spd.y = -AYU_JUMP_POW;

	AyuLeftJumpExec(obj);
}


/* --------------------------------------------------------------
	GWvs
 -------------------------------------------------------------- */
function AyuLeftJumpExec(obj){
	AyuAttackCheck(obj);

	obj.spd.y += AYU_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
		obj.exec = AyuJumpStanInit;
	}
}

/* --------------------------------------------------------------
	GWv
 -------------------------------------------------------------- */
function AyuJumpStanInit(obj){
	obj.exec = AyuJumpStanExec;
	
	obj.spd.x = 0;
	obj.spd.y = 0;
	obj.count = 20;

	StageSetShake(10,3);
	SePlay(SE_CANNON,obj.pos);

	AyuJumpStanExec(obj);
}


/* --------------------------------------------------------------
	GWvs
 -------------------------------------------------------------- */
function AyuJumpStanExec(obj){
	AyuAttackCheck(obj);

	obj.spd.y += AYU_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(AyuCollisionCheck(obj)){
	}
	
	if(--obj.count < 0){
		obj.exec = AyuThinkInit;
	}
}



// n``FbN
function AyuCollisionCheck(obj){
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = AyuCollisionRect;

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 3;
	var j_min = Math.floor((pos.y - 10) / COLLISION_SECTOR_HEIGHT) - 3;
	var i_max = i_min + 6;
	var j_max = j_min + 6;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var t3 = 0x7FFFFFFF;
	var m3 =-0x7FFFFFFF;
	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;
	
	var speed = Vec2dCreate(0,0);

	var PL_Y_LENGTH = 2;
	
	
	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH + 2;
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;
				
				if(r1 < l2){
				}else if(r2 < l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{

					if(t2 < t3)	t3 = t2;
					if(m2 > m3)	m3 = m2;
					
					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}
					}

				}

				data = data.post;
			}
		}
	}

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							
							if(m1 - t2 < MAX_Y_LENGTH){

								speed.y +=  data.param.spd.y;

								var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
								if(vec.y > y){
									vec.y = y;
									if(!data.param.spd.y){
										speed.y = 0;
									}
								}

								if(spd.y > 0)	check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;

								// `Abvf[g
								l1 = rect.x + vec.x;
								t1 = rect.y + vec.y;
								r1 = l1 + rect.w;
								m1 = t1 + rect.h;
								
//								vec = Vec2dAdd(vec,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
							if(vec.y > y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							
						}
					}

					// Ɉړ
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = m2 - rect.y + 0.001; 			// ɕ␳
							if(vec.y < y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;


						}
					}

					PL_Y_LENGTH += Math.abs(data.param.spd.y);
					//vec = Vec2dAdd(vec,data.param.spd);
					//speed = Vec2dAdd( speed , data.param.spd);

					// `Abvf[g
					l1 = rect.x + vec.x;
					t1 = rect.y + vec.y;
					r1 = l1 + rect.w;
					m1 = t1 + rect.h;

				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	l1 = rect.x + vec.x;
	t1 = rect.y + vec.y;
	r1 = l1 + rect.w;
	m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x - Math.abs(data.param.spd.x) >= -0.001){
						// ubN̍[
						
						if(r1 - l2 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = l2 - rect.x - rect.w - 0.001;  // ɕ␳
							if(vec.x > x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							
						}
					}

					// Ɉړ
					if(spd.x - Math.abs(data.param.spd.x) <= 0.001){
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = r2 - rect.x + 0.001;  // Eɕ␳
							if(vec.x < x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;

						}
					}
				}

				data = data.post;
			}
		}
	}

	vec = Vec2dAdd(speed,vec);
	pos.x = vec.x;


	// ǐڐG
	if(check4){
	}

	// ǖ
	if(check2){
		return false;
	}
	
	
	pos.y = vec.y;

	// V
	if(check3){
		spd.y = 0;
	}

	// n
	if(check){
		spd.y = 0;
	}
	
	return check;
}


/* --------------------------------------------------------------
	炢֐
 -------------------------------------------------------------- */
function AyuHitTestFunc(obj,type,pos,spd){

	switch(type){
	case HITTEST_TYPE_PLAYER:
		return false;
	case HITTEST_TYPE_PLAYER_ITEM:
	case HITTEST_TYPE_STAGE:
	case HITTEST_TYPE_TURTLE_ATT:
	case HITTEST_TYPE_STAR:
	case HITTEST_TYPE_STAGE_KILL:
		// ATtB[hWJ
		EffectSpriteCreate(obj.task,{pos:pos,asset:"at_field"});
		return false;
		
	case HITTEST_TYPE_TARAI:
		AyuClushInit(obj);
		break;
	}
	
	return true;
}




/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function AyuAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = AyuCollisionRect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_ENEMY);
		}

		data = list;
	}


	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_BOSS);
		}

		data = list;
	}
}





/* --------------------------------------------------------------
	炢֐
 -------------------------------------------------------------- */
function AyuTaraiFunc(){
	var obj = AYU_TASK.obj;
	obj.flg &= ~AYU_FLG_ATTACK;
	obj.flg |= AYU_FLG_STAY;
//	AyuTaraiWaitInit(obj);
}



/* --------------------------------------------------------------
	GWv
 -------------------------------------------------------------- */
function AyuTaraiWaitInit(obj){
	obj.exec = AyuTaraiWaitExec;
	AyuTaraiWaitExec(obj);
}


/* --------------------------------------------------------------
	GWvs
 -------------------------------------------------------------- */
function AyuTaraiWaitExec(obj){

}
