/* -----------------------------------------------------------------------------
	C֐
	t@C  : cannon.as
			: hakuhin (c) 2006/12/08
	
			: Cp֐
 ----------------------------------------------------------------------------- */


CANNON_WIDTH  = 20;
CANNON_HEIGHT = 20;
CANNON_RADIUS = CANNON_WIDTH / 2;
CANNON_MOVE_SPD      = 1.5;


CannonCollisionRect = {
	x : -CANNON_RADIUS,
	y : -CANNON_HEIGHT,
	w :  CANNON_WIDTH,
	h :  CANNON_HEIGHT
};


CANNON_TYPE_RIGHT = 0;	// E
CANNON_TYPE_LEFT = 1;	// 
CANNON_TYPE_BOTH = 2;	// E


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function CannonTaskCreate(task,param){
	return TaskCreate(
		CannonInitalize,
		CannonExecute,
		CannonDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function CannonInitalize(obj,task,param){
	obj.task = task;

	obj.type = param.type;

	obj.depth = EffectDepthGet();
	switch(obj.type){
	case CANNON_TYPE_RIGHT:
		obj.mc = _root.sprite.attachMovie("cannon","_" + obj.depth.depth, obj.depth.depth);
		break;
	case CANNON_TYPE_LEFT:
		obj.mc = _root.sprite.attachMovie("cannon","_" + obj.depth.depth, obj.depth.depth);
		obj.mc._xscale = -100;
		break;
	case CANNON_TYPE_BOTH:
		obj.mc = _root.sprite.attachMovie("cannon_both","_" + obj.depth.depth, obj.depth.depth);
		break;
	}

	// RWo^
	obj.collision = {pos : obj.pos,rect: CannonCollisionRect,type : COLLISION_TYPE_RECT,func : null,param : obj};
	CollisionAttach(obj.collision);

	obj.pos = Vec2dClone(param.pos);
	obj.exec = CannonStayInit;

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
	obj.frame = 0;
	
	CannonExecute();
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function CannonExecute(obj){
	var s = Math.abs(PLAYER_TASK.obj.pos.x - obj.pos.x);

	// XN[ɓ
	var vec = ScreenPosition(obj.pos);

	var x = vec.x - GAME_WIDTH_HALF;
	var y = vec.y - GAME_HEIGHT_HALF;

	if(s > 50){
		if((Math.abs(x) < 200) && (Math.abs(y) < 180)){
			if(++ obj.frame > 150){
				obj.frame = 0;
				var dir;
				switch(obj.type){
				case CANNON_TYPE_RIGHT:
					dir = 1;
					break;
				case CANNON_TYPE_LEFT:
					dir = -1;
					break;
				case CANNON_TYPE_BOTH:
					dir = MathSign(PLAYER_TASK.obj.pos.x - obj.pos.x);
					break;
				}
				
				// C
				PtcCannonFireCreate(obj.pos,dir);
				SePlay(SE_CANNON,obj.pos);

				TaiyakiTaskCreate(STAGE_TASK,{
					pos : obj.pos,
					dir : dir
				});
			}
		}
	}
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function CannonDelete(obj){

	CollisionRemove(obj.collision);
	obj.collision = null;

	EffectDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}



/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function CannonAttachScript(param,id,task){
	CannonTaskCreate(task,{
		pos : param.pos,
		type: param.type,
		id  : id
	});
}









/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function OutOfCannonTaskCreate(task,param){
	return TaskCreate(
		OutOfCannonInitalize,
		OutOfCannonExecute,
		OutOfCannonDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function OutOfCannonInitalize(obj,task,param){
	obj.task = task;
	obj.frame = param.frame_ofs;
	obj.frame_end = param.frame_end;

	OutOfCannonExecute();
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function OutOfCannonExecute(obj){
	if(++ obj.frame > obj.frame_end){
		obj.frame = 0;
		
		var pos = ScreenPosition(PLAYER_TASK.obj.pos);
		pos.x = GAME_WIDTH + 10;
		pos = WorldPosition(pos);
		
		// C
		SePlay(SE_CANNON,pos);

		TaiyakiTaskCreate(STAGE_TASK,{
			pos : pos,
			dir : -1
		});
	}

}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function OutOfCannonDelete(obj){
}



/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function OutOfCannonAttachScript(param,id,task){
	OutOfCannonTaskCreate(task,{
		pos : param.pos,
		frame_ofs: param.frame_ofs,
		frame_end: param.frame_end,
		id  : id
	});
}