/* -----------------------------------------------------------------------------
	L֐
	t@C  : cat.as
			: hakuhin (c) 2006/12/08
	
			: Lp֐
 ----------------------------------------------------------------------------- */

CAT_WIDTH  = 14;
CAT_HEIGHT = 27;
CAT_BASE_HEIGHT = 32;
CAT_RADIUS = CAT_WIDTH / 2;

CAT_MOVE_INT      = 30;


CAT_TYPE_ROT_000 = 0;
CAT_TYPE_ROT_090 = 1;
CAT_TYPE_ROT_180 = 2;
CAT_TYPE_ROT_270 = 3;




CatCollisionRectRot000 = {
	x : -CAT_RADIUS,
	y : -CAT_HEIGHT,
	w :  CAT_WIDTH,
	h :  CAT_HEIGHT
};

CatCollisionRectRot090 = {
	x :  0,
	y : -CAT_RADIUS,
	w :  CAT_HEIGHT,
	h :  CAT_RADIUS
};

CatCollisionRectRot180 = {
	x :  -CAT_RADIUS,
	y :  0,
	w :  CAT_HEIGHT,
	h :  CAT_RADIUS
};

CatCollisionRectRot270 = {
	x : -CAT_HEIGHT,
	y : -CAT_RADIUS,
	w :  0,
	h :  CAT_RADIUS
};


CAT_FLG_INSTANCE = 0x01;	// CX^Xς
CAT_FLG_VISIBLE  = 0x02;	// ̈


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function CatTaskCreate(task,param){
	return TaskCreate(
		CatInitalize,
		CatExecute,
		CatDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function CatInitalize(obj,task,param){
	obj.task = task;
	obj.type = param.type;
	obj.next = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	
	switch(obj.type){
	case CAT_TYPE_ROT_000:	obj.base.y += CAT_BASE_HEIGHT;	break;
	case CAT_TYPE_ROT_090:	obj.base.x -= CAT_BASE_HEIGHT;	break;
	case CAT_TYPE_ROT_180:	obj.base.y -= CAT_BASE_HEIGHT;	break;
	case CAT_TYPE_ROT_270:	obj.base.x += CAT_BASE_HEIGHT;	break;
	}

	obj.id = param.id;


	obj.pos = Vec2dClone(obj.base);
	obj.spd = Vec2dCreate(0,0);
	
	obj.depth = EnemyDepthGet();

    obj.mc = _root.sprite.attachMovie("cat","_" + obj.depth.depth, obj.depth.depth);
	AnmCmdInit(obj.mc);
	obj.mc._rotation = obj.type * 90;

	switch(obj.type){
		case CAT_TYPE_ROT_000:	obj.rect = CatCollisionRectRot000;	break;
		case CAT_TYPE_ROT_090:	obj.rect = CatCollisionRectRot090;	break;
		case CAT_TYPE_ROT_180:	obj.rect = CatCollisionRectRot190;	break;
		case CAT_TYPE_ROT_270:	obj.rect = CatCollisionRectRot270;	break;
	}

	obj.hittest = {pos : obj.pos,rect: obj.rect,func:CatHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_ENEMY);


	obj.exec = CatStayInit;
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function CatExecute(obj){
	obj.exec(obj);	// s
	
	obj.hittest.pos = obj.pos;

	AnmCmdPlay(obj.mc);
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function CatDelete(obj){

	FreeDepthPurge(obj.depth);
	if(obj.hittest)	HittestRemove(obj.hittest);
	
	obj.mc.removeMovieClip();
	obj.mc = null;

}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function CatAttachScript(param,id,task){
	CatTaskCreate(task,{
		pos : param.pos,
		type: param.type,
		id  : id
	});
}


/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function CatBlowInit(obj){
	if(obj.depth){
		FreeDepthPurge(obj.depth);
	}
	// [x`FW
	obj.depth = EffectDepthGet();
	obj.mc.swapDepths(obj.depth.depth);

	obj.exec = CatBlowExec;
	obj.mc.ANM_GOTO = "_rotate";
	obj.spd.y = -5;
	STAGE_SCRIPT_WORK[obj.id] = false;


	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.count = 0;
	SePlay(SE_CLUSH,obj.pos);

	CatBlowExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function CatBlowExec(obj){
	obj.spd.y += PLAYER_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);

	if(++obj.count > 120){
		TaskDelete(obj.task);
		return;
	}
}


/* --------------------------------------------------------------
	ҋ@
 -------------------------------------------------------------- */
function CatStayInit(obj){
	obj.exec = CatStayExec;

	obj.frame = 0;
	CatStayExec(obj);
}


/* --------------------------------------------------------------
	ҋ@s
 -------------------------------------------------------------- */
function CatStayExec(obj){
	
	// ߂ɂ鎞͔Ȃ
	if(obj.type == CAT_TYPE_ROT_000){
		var len = Math.abs(obj.base.x - PLAYER_TASK.obj.pos.x);
		if(len > 25)	obj.frame ++;
	}else{
		obj.frame ++;
	}

	if(obj.frame > 60){
		obj.exec = CatUpMoveInit;
	}
	
}

/* --------------------------------------------------------------
	ړ
 -------------------------------------------------------------- */
function CatUpMoveInit(obj){
	obj.exec = CatUpMoveExec;
	obj.pos = Vec2dClone(obj.base);
	obj.spd = Vec2dSub(obj.next,obj.base);
	obj.spd = Vec2dScale(obj.spd,1 / CAT_MOVE_INT);
	obj.frame = 0;
	CatUpMoveExec(obj);
}


/* --------------------------------------------------------------
	ړs
 -------------------------------------------------------------- */
function CatUpMoveExec(obj){
	CatAttackCheck(obj);
	
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	if( ++ obj.frame > CAT_MOVE_INT){
		obj.exec = CatAttackInit;
	}
}

/* --------------------------------------------------------------
	U
 -------------------------------------------------------------- */
function CatAttackInit(obj){
	obj.exec = CatAttackExec;
	obj.frame = 0;
	CatAttackExec(obj);
}


/* --------------------------------------------------------------
	ړs
 -------------------------------------------------------------- */
function CatAttackExec(obj){
	CatAttackCheck(obj);

	if( ++ obj.frame > 60){
		obj.exec = CatDownMoveInit;
	}
}

/* --------------------------------------------------------------
	o
 -------------------------------------------------------------- */
function CatDownMoveInit(obj){
	obj.exec = CatDownMoveExec;
	obj.pos = Vec2dClone(obj.next);
	obj.spd = Vec2dSub(obj.base,obj.next);
	obj.spd = Vec2dScale(obj.spd,1 / CAT_MOVE_INT);
	obj.frame = 0;
	CatDownMoveExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function CatDownMoveExec(obj){
	CatAttackCheck(obj);
	
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	if( ++ obj.frame > CAT_MOVE_INT){
		obj.exec = CatStayInit;
	}
}


/* --------------------------------------------------------------
	炢֐
 -------------------------------------------------------------- */
function CatHitTestFunc(obj,type,pos,spd){

	switch(type){
	case HITTEST_TYPE_PLAYER:
		return false;
	case HITTEST_TYPE_PLAYER_ITEM:
		obj.spd.x = MathSign(spd.x) * MUSHROOM_MOVE_SPD;
		CatBlowInit(obj);
		break;
	case HITTEST_TYPE_STAGE:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * MUSHROOM_MOVE_SPD;
		CatBlowInit(obj);
		
	case HITTEST_TYPE_STAR:
	case HITTEST_TYPE_STAGE_KILL:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * MUSHROOM_MOVE_SPD;
		CatBlowInit(obj);
		break;
	}
	
	return true;
}


/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function CatAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_ENEMY,obj.pos,obj.spd);
		}

		data = list;
	}
}
