/* -----------------------------------------------------------------------------
	bNTbN֐
	t@C  : rucksack.as
			: hakuhin (c) 2006/12/17
	
			: bNTbNp֐
 ----------------------------------------------------------------------------- */

RUCKSACK_WIDTH  = 20;
RUCKSACK_HEIGHT = RUCKSACK_WIDTH;
RUCKSACK_RADIUS = RUCKSACK_WIDTH / 2;
RUCKSACK_MOVE_SPD      = 1.0
RUCKSACK_JUMP_SPD      = 5.0
RUCKSACK_G    		 = 0.2
RUCKSACK_ATTACH_WIDTH  = 200;
RUCKSACK_ATTACH_HEIGHT = 180;
RUCKSACK_REMOVE_WIDTH  = 280;
RUCKSACK_REMOVE_HEIGHT = 300;


RucksackCollisionRect = {
	x : -RUCKSACK_RADIUS + 2,
	y : -RUCKSACK_HEIGHT,
	w :  RUCKSACK_WIDTH - 4,
	h :  RUCKSACK_HEIGHT
};


RucksackStanCollisionRect = {
	x : -RUCKSACK_RADIUS + 2,
	y : -RUCKSACK_RADIUS,
	w :  RUCKSACK_WIDTH - 4,
	h :  RUCKSACK_RADIUS
};


RucksackStageCollisionRect = {
	x : -RUCKSACK_RADIUS + 2,
	y : -RUCKSACK_RADIUS,
	w :  RUCKSACK_WIDTH - 4,
	h :  RUCKSACK_RADIUS / 2
};


RUCKSACK_FLG_INSTANCE	= 0x01;	// CX^Xς
RUCKSACK_FLG_VISIBLE	= 0x02;	// ̈
RUCKSACK_FLG_COLLISION 	= 0x04;	// RW

RUCKSACK_TYPE_JUMP			= 0;	// CX^Xς
RUCKSACK_TYPE_MOVE			= 1;	// CX^Xς
RUCKSACK_TYPE_UPDOWN_FLY	= 2;	// CX^Xς




/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function RucksackTaskCreate(task,param){
	return TaskCreate(
		RucksackInitalize,
		RucksackExecute,
		RucksackDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function RucksackInitalize(obj,task,param){
	obj.task = task;
	obj.pos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.type = param.type;
	obj.status = 0;
	obj.id = param.id;
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function RucksackExecute(obj){
	obj.exec(obj);	// s

	// XN[ɓ
	var x = obj.base.x - (ScrollData.pos.x + GAME_WIDTH_HALF);
	var y = obj.base.y - (ScrollData.pos.y + GAME_HEIGHT_HALF);

	if((Math.abs(x) < RUCKSACK_ATTACH_WIDTH) && (Math.abs(y) < RUCKSACK_ATTACH_HEIGHT)){
		if(!(obj.flg & RUCKSACK_FLG_VISIBLE)){
			if(!(obj.flg & RUCKSACK_FLG_INSTANCE)){
				obj.exec = RucksackAppearInit;
			}
			obj.flg |= RUCKSACK_FLG_VISIBLE;
		}
	}else{
		obj.flg &= ~RUCKSACK_FLG_VISIBLE;
	}


	if(obj.mc){
		if(obj.flg & RUCKSACK_FLG_COLLISION){

			// XN[ɓ
			var x = obj.pos.x - (ScrollData.pos.x + GAME_WIDTH_HALF);
			var y = obj.pos.y - (ScrollData.pos.y + GAME_HEIGHT_HALF);

			if((Math.abs(x) > RUCKSACK_REMOVE_WIDTH) || (Math.abs(y) > RUCKSACK_REMOVE_HEIGHT)){
				obj.exec = RucksackRemoveInit;
				if(obj.id == -1){
					TaskDelete(obj.task);
					return;
				}
			}
		}

		if(StageEndPos(obj)){
			obj.dir *= -1;
			obj.spd.x *= -1;
		}

		AnmCmdPlay(obj.mc);
		obj.mc._x = Math.floor(obj.pos.x + 0.5);
		obj.mc._y = Math.floor(obj.pos.y + 0.5);
		obj.mc._xscale = obj.dir * -100;
	}
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function RucksackDelete(obj){
	RucksackRemoveInit(obj);
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function RucksackAttachScript(param,id,task){
	RucksackTaskCreate(task,{
		pos : param.pos,
		type: param.type,
		id  : id
	});
}


/* --------------------------------------------------------------
	Ȃ
 -------------------------------------------------------------- */
function RucksackStayExec(obj){

}


/* --------------------------------------------------------------
	G
 -------------------------------------------------------------- */
function RucksackAppearInit(obj){
	obj.flg |= RUCKSACK_FLG_INSTANCE;
	obj.flg |= RUCKSACK_FLG_COLLISION;
	obj.exec = RucksackAppearExec;

	obj.pos = Vec2dClone(obj.base);
	obj.dir = MathSign((ScrollData.pos.x + GAME_WIDTH_HALF) - obj.base.x);
	
	obj.spd = Vec2dCreate(0,0);
	
	if(!obj.depth){
		obj.depth = EnemyDepthGet();
	}

	if(!obj.mc){
	    obj.mc = _root.sprite.attachMovie("rucksack","_" + obj.depth.depth, obj.depth.depth);
		AnmCmdInit(obj.mc);
	}

	obj.rect = RucksackCollisionRect;

	if(!obj.hittest){
		obj.hittest = {pos : obj.pos,rect: obj.rect,func:RucksackHitTestFunc,param:obj};
		HittestAttach(obj.hittest,HITTEST_TYPE_ENEMY);
	}

	RucksackAppearExec(obj);
}


/* --------------------------------------------------------------
	Gs
 -------------------------------------------------------------- */
function RucksackAppearExec(obj){
	switch(obj.type){
	case RUCKSACK_TYPE_JUMP:
		obj.exec = RucksackJumpInit;
		obj.status = RUCKSACK_TYPE_JUMP;
		break;
	case RUCKSACK_TYPE_MOVE:
		obj.exec = RucksackMoveInit;
		obj.status = RUCKSACK_TYPE_MOVE;
		break;
		
	case RUCKSACK_TYPE_UPDOWN_FLY:
		obj.exec = RucksackUpDownFlyInit;
		obj.status = RUCKSACK_TYPE_JUMP;
		break;	
		
	}
}


/* --------------------------------------------------------------
	Gj
 -------------------------------------------------------------- */
function RucksackRemoveInit(obj){
	obj.flg &= ~RUCKSACK_FLG_INSTANCE;
	obj.exec = RucksackRemoveExec;

	if(obj.depth){
		FreeDepthPurge(obj.depth);
		obj.depth = null;
	}

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	if(obj.mc){
		obj.mc.removeMovieClip();
		obj.mc = null;
	}

	RucksackRemoveExec(obj);
}

/* --------------------------------------------------------------
	Gjs
 -------------------------------------------------------------- */
function RucksackRemoveExec(obj){
	obj.exec = RucksackStayExec;
}


/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function RucksackBlowInit(obj){
	if(obj.depth){
		FreeDepthPurge(obj.depth);
	}
	// [x`FW
	obj.depth = EffectDepthGet();
	obj.mc.swapDepths(obj.depth.depth);

	obj.exec = RucksackBlowExec;
	obj.spd.y = -5;
	if(obj.id != -1)	STAGE_SCRIPT_WORK[obj.id] = false;
	


	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	obj.count = 0;

	obj.flg &= ~RUCKSACK_FLG_COLLISION;

	RucksackBlowExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function RucksackBlowExec(obj){
	obj.spd.y += RUCKSACK_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);

	if(++obj.count > 120){
		TaskDelete(obj.task);
		return;
	}
}

/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function RucksackJumpInit(obj){
	obj.exec = RucksackJumpExec;
	obj.mc.ANM_GOTO = "_fly";
	obj.spd.x = RUCKSACK_MOVE_SPD * obj.dir;

	RucksackJumpExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function RucksackJumpExec(obj){
	RucksackAttackCheck(obj);

	obj.spd.y += RUCKSACK_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;

	if(obj.flg & RUCKSACK_FLG_COLLISION){
		if(RucksackCollisionCheck(obj)){
			obj.spd.y = -RUCKSACK_JUMP_SPD;
		}
	}

	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;
}




/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function RucksackUpDownFlyInit(obj){
	obj.exec = RucksackUpDownFlyExec;
	obj.mc.ANM_GOTO = "_fly";
	
	obj.base = Vec2dClone(obj.pos);
	obj.spd.x = 0;
	
	obj.rot = 0;

	RucksackUpDownFlyExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function RucksackUpDownFlyExec(obj){
	RucksackAttackCheck(obj);

	obj.rot += 3;
	if(obj.rot > 360)	obj.rot -= 360;
	
	obj.pos.y = obj.base.y + Math.sin(obj.rot * Math.PI / 180) * 30;
	obj.spd = Vec2dSub(obj.pos,obj.base);

	obj.hittest.pos = obj.pos;
}


/* --------------------------------------------------------------
	GԂꏉ
 -------------------------------------------------------------- */
function RucksackCrushInit(obj){

	obj.exec = RucksackCrushExec;
	obj.mc.ANM_GOTO = "_crush";
	obj.spd = Vec2dCreate(0,0);
	if(obj.id != -1)	STAGE_SCRIPT_WORK[obj.id] = false;


	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.count = 0;

	RucksackCrushExec(obj);
}


/* --------------------------------------------------------------
	GԂs
 -------------------------------------------------------------- */
function RucksackCrushExec(obj){
	if(++obj.count > 30){
		TaskDelete(obj.task);
		return;
	}
}


/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function RucksackMoveInit(obj){
	obj.exec = RucksackMoveExec;
	obj.spd.x = RUCKSACK_MOVE_SPD * obj.dir;
	obj.spd.y = 0;
	obj.mc.ANM_GOTO = "_normal";
	
	obj.status = RUCKSACK_TYPE_MOVE;

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	obj.count = 0;
	
	RucksackMoveExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function RucksackMoveExec(obj){
	obj.count ++;

	// qbgǉ
	if(obj.count == 10){
		if(!obj.hittest){
			obj.hittest = {pos : obj.pos,rect: obj.rect,func:RucksackHitTestFunc,param:obj};
			HittestAttach(obj.hittest,HITTEST_TYPE_ENEMY);
		}
	}

	if(obj.count > 10){
		RucksackAttackCheck(obj);
	}
	
	
	obj.spd.y += RUCKSACK_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
		
	if(obj.flg & RUCKSACK_FLG_COLLISION){
		if(RucksackCollisionCheck(obj)){
			obj.spd.y = 0;
		}
	}

	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;
}


/* --------------------------------------------------------------
	n`Փ˃`FbN
 -------------------------------------------------------------- */
/*
function RucksackCollisionCheck(obj){
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = obj.rect;


	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 20) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;

	var PL_Y_LENGTH = 0;
	

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH + 2;
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y >= 0){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								var y = t2 - rect.y - rect.h;  // ɕ␳
								if(vec.y > y)	vec.y = y;

								check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
								
								vec.y += data.param.spd.y;
//								vec = Vec2dAdd(vec,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y >= 0){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							var y = t2 - rect.y - rect.h;  // ɕ␳
							if(vec.y > y)	vec.y = y;

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}else{
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							var y = m2 - rect.y; 			// ɕ␳
							if(vec.y < y)	vec.y = y;

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							check3 = true;
						}
					}
					
					// xf
					vec.y += data.param.spd.y;
					PL_Y_LENGTH += Math.abs(data.param.spd.y);
//					vec = Vec2dAdd(vec,data.param.spd);
					
				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	var l1 = rect.x + vec.x;
	var t1 = rect.y + vec.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x > 0){
						// ubN̍[
						if(r1 - l2 <= MAX_X_LENGTH){
							var x = l2 - rect.x - rect.w;  // ɕ␳
							if(vec.x > x)	vec.x = x;

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							obj.dir *= -1;
							spd.x = RUCKSACK_MOVE_SPD * obj.dir;
						}

					// Ɉړ
					}else{
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){
							var x = r2 - rect.x;  // Eɕ␳
							if(vec.x < x)	vec.x = x;

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
							obj.dir *= -1;
							spd.x = RUCKSACK_MOVE_SPD * obj.dir;
						}
					}

					// xf
//					vec.x += data.param.spd.x;
//					vec = Vec2dAdd(vec,data.param.spd);

				}

				data = data.post;
			}
		}
	}


	pos.x = vec.x;


	if(check2){

		return false;
	
	}else{
		pos.y = vec.y;
		if(check3){
			spd.y = 0;
		}
	}
	
	return check;
}
*/

// n``FbN
function RucksackCollisionCheck(obj){
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = obj.rect;

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 10) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var t3 = 0x7FFFFFFF;
	var m3 =-0x7FFFFFFF;
	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;
	
	var speed = Vec2dCreate(0,0);

	var PL_Y_LENGTH = 2;
	
	
	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH + 2;
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;
				
				if(r1 < l2){
				}else if(r2 < l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{

					if(t2 < t3)	t3 = t2;
					if(m2 > m3)	m3 = m2;
					
					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}
					}

				}

				data = data.post;
			}
		}
	}

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							
							if(m1 - t2 < MAX_Y_LENGTH){

								speed.y +=  data.param.spd.y;

								var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
								if(vec.y > y){
									vec.y = y;
									if(!data.param.spd.y){
										speed.y = 0;
									}
								}

								if(spd.y > 0)	check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;

								// `Abvf[g
								l1 = rect.x + vec.x;
								t1 = rect.y + vec.y;
								r1 = l1 + rect.w;
								m1 = t1 + rect.h;
								
//								vec = Vec2dAdd(vec,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
							if(vec.y > y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							
						}
					}

					// Ɉړ
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = m2 - rect.y + 0.001; 			// ɕ␳
							if(vec.y < y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;


						}
					}

					PL_Y_LENGTH += Math.abs(data.param.spd.y);
					//vec = Vec2dAdd(vec,data.param.spd);
					//speed = Vec2dAdd( speed , data.param.spd);

					// `Abvf[g
					l1 = rect.x + vec.x;
					t1 = rect.y + vec.y;
					r1 = l1 + rect.w;
					m1 = t1 + rect.h;

				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	l1 = rect.x + vec.x;
	t1 = rect.y + vec.y;
	r1 = l1 + rect.w;
	m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x - Math.abs(data.param.spd.x) >= -0.001){
						// ubN̍[
						
						if(r1 - l2 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = l2 - rect.x - rect.w - 0.001;  // ɕ␳
							if(vec.x > x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							
						}
					}

					// Ɉړ
					if(spd.x - Math.abs(data.param.spd.x) <= 0.001){
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = r2 - rect.x + 0.001;  // Eɕ␳
							if(vec.x < x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
						}
					}
				}

				data = data.post;
			}
		}
	}

	vec = Vec2dAdd(speed,vec);
	pos.x = vec.x;


	// ǐڐG
	if(check4){
		obj.dir = ((check4 == 1) ? -1 : 1);
		spd.x = RUCKSACK_MOVE_SPD * obj.dir;
	}

	// ǖ
	if(check2){
		return false;
	}
	
	
	pos.y = vec.y;

	// V
	if(check3){
		spd.y = 0;
	}

	// n
	if(check){
	}
	
	return check;
}

/* --------------------------------------------------------------
	炢֐
 -------------------------------------------------------------- */
function RucksackHitTestFunc(obj,type,pos,spd){
	switch(type){
	case HITTEST_TYPE_PLAYER:
		switch(obj.status){
			case RUCKSACK_TYPE_JUMP:	RucksackMoveInit(obj);		break;
			case RUCKSACK_TYPE_MOVE:	RucksackCrushInit(obj);		break;
		}
		break;
	case HITTEST_TYPE_PLAYER_ITEM:
		var dir = MathSign(spd.x);
		obj.spd.x = MathSign(spd.x) * RUCKSACK_MOVE_SPD;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		RucksackBlowInit(obj);
		break;
	case HITTEST_TYPE_TURTLE_ATT:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * RUCKSACK_MOVE_SPD;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		RucksackBlowInit(obj);
		break;
	case HITTEST_TYPE_STAGE:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * RUCKSACK_MOVE_SPD;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		RucksackStanBrowInit(obj);
		break;
	case HITTEST_TYPE_STAR:
	case HITTEST_TYPE_STAGE_KILL:

		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * RUCKSACK_MOVE_SPD;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		RucksackBlowInit(obj);
		break;
	}
	
	return true;
}





/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function RucksackAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_ENEMY);
		}

		data = list;
	}
}
