/* -----------------------------------------------------------------------------
	wbg֐
	t@C  : snowman_helmet.as
			: hakuhin (c) 2006/12/17
	
			: wbgp֐
 ----------------------------------------------------------------------------- */

HELMET_WIDTH  = 20;
HELMET_G  = 0.5;
HELMET_HEIGHT = HELMET_WIDTH;
HELMET_RADIUS = HELMET_WIDTH / 2;
HELMET_MOVE_SPD      = 1.0;
HELMET_TURTLE_SPD	 = 3.5;
HELMET_ATTACH_WIDTH  = 200;
HELMET_ATTACH_HEIGHT = 180;
HELMET_REMOVE_WIDTH  = 280;
HELMET_REMOVE_HEIGHT = 300;


HelmetCollisionRect = {
	x : -HELMET_RADIUS + 2,
	y : -HELMET_HEIGHT,
	w :  HELMET_WIDTH - 4,
	h :  HELMET_HEIGHT
};


HelmetStanCollisionRect = {
	x : -HELMET_RADIUS + 2,
	y : -HELMET_RADIUS,
	w :  HELMET_WIDTH - 4,
	h :  HELMET_RADIUS
};


HelmetStageCollisionRect = {
	x : -HELMET_RADIUS,
	y : -HELMET_RADIUS,
	w :  HELMET_WIDTH,
	h :  HELMET_RADIUS - 6
};


HELMET_FLG_INSTANCE 	= 0x01;	// CX^Xς
HELMET_FLG_VISIBLE  	= 0x02;	// ̈
HELMET_FLG_STAN	 		= 0x04;	// J
HELMET_FLG_COLLISION	= 0x08;	// RW
HELMET_FLG_PLAYER_HIT	= 0x10;	// vC[RW
HELMET_FLG_DEC			= 0x20;	// C



/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function HelmetTaskCreate(task,param){
	return TaskCreate(
		HelmetInitalize,
		HelmetExecute,
		HelmetDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function HelmetInitalize(obj,task,param){
	obj.task = task;
	obj.base = Vec2dClone(param.pos);
	obj.id = param.id;

	obj.exec = HelmetStayExec;
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function HelmetExecute(obj){
	obj.exec(obj);	// s

	// XN[ɓ
	var x = obj.base.x - (ScrollData.pos.x + GAME_WIDTH_HALF);
	var y = obj.base.y - (ScrollData.pos.y + GAME_HEIGHT_HALF);
	
	if((Math.abs(x) < HELMET_ATTACH_WIDTH) && (Math.abs(y) < HELMET_ATTACH_HEIGHT)){
		if(!(obj.flg & HELMET_FLG_VISIBLE)){
			if(!(obj.flg & HELMET_FLG_INSTANCE)){
				obj.exec = HelmetAppearInit;
			}
			obj.flg |= HELMET_FLG_VISIBLE;
		}
	}else{
		obj.flg &= ~HELMET_FLG_VISIBLE;
	}


	if(obj.mc){

		if(obj.flg & HELMET_FLG_COLLISION){
			if(HelmetCollisionCheck(obj)){
				obj.spd.y = 0;
				if(obj.flg & HELMET_FLG_DEC)	obj.spd.x *= 0.9;
	//			obj.spd.x = HELMET_MOVE_SPD * obj.dir;
			}
		}

		if(obj.flg & HELMET_FLG_COLLISION){

			// XN[ɓ
			var x = obj.pos.x - (ScrollData.pos.x + GAME_WIDTH_HALF);
			var y = obj.pos.y - (ScrollData.pos.y + GAME_HEIGHT_HALF);

			if((Math.abs(x) > HELMET_REMOVE_WIDTH) || (Math.abs(y) > HELMET_REMOVE_HEIGHT)){
				obj.exec = HelmetRemoveInit;
				if(obj.id == -1){
					TaskDelete(obj.task);
					return;
				}
			}
		}

		if(StageEndPos(obj)){
			obj.dir *= -1;
			obj.spd.x *= -1;
		}

		AnmCmdPlay(obj.mc);
		obj.mc._x = Math.floor(obj.pos.x + 0.5);
		obj.mc._y = Math.floor(obj.pos.y + 0.5);
	}
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function HelmetDelete(obj){
	HelmetRemoveInit(obj);
	
	// vC[̃bNO
	if(PLAYER_TASK.obj.have == obj){
		PLAYER_TASK.obj.have = null;
	}
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function HelmetAttachScript(param,id,task){
	HelmetTaskCreate(task,{
		pos : param.pos,
		id  : id
	});
}


/* --------------------------------------------------------------
	Ȃ
 -------------------------------------------------------------- */
function HelmetStayExec(obj){

}


/* --------------------------------------------------------------
	G
 -------------------------------------------------------------- */
function HelmetAppearInit(obj){
	obj.flg |= HELMET_FLG_INSTANCE;
	obj.flg |= HELMET_FLG_COLLISION;
	obj.exec = HelmetAppearExec;

	obj.pos = Vec2dClone(obj.base);
	obj.dir = MathSign((ScrollData.pos.x + GAME_WIDTH_HALF) - obj.base.x);
	
	obj.spd = Vec2dCreate(0,0);
	obj.spd_max = HELMET_MOVE_SPD;
	
	if(!obj.depth){
		obj.depth = EnemyDepthGet();
	}

	if(!obj.mc){
	    obj.mc = _root.sprite.attachMovie("snowman_hel","_" + obj.depth.depth, obj.depth.depth);
		AnmCmdInit(obj.mc);
	}

	obj.rect = HelmetCollisionRect;

	if(!obj.hittest){
		obj.hittest = {pos : obj.pos,rect: obj.rect,func:HelmetHitTestFunc,param:obj};
		HittestAttach(obj.hittest,HITTEST_TYPE_ENEMY);
		obj.flg |= HELMET_FLG_PLAYER_HIT;
	}

	HelmetAppearExec(obj);
}


/* --------------------------------------------------------------
	Gs
 -------------------------------------------------------------- */
function HelmetAppearExec(obj){
	obj.exec = HelmetMoveInit;
}


/* --------------------------------------------------------------
	Gj
 -------------------------------------------------------------- */
function HelmetRemoveInit(obj){
	obj.flg &= ~HELMET_FLG_INSTANCE;
	obj.exec = HelmetRemoveExec;

	if(obj.depth){
		FreeDepthPurge(obj.depth);
		obj.depth = null;
	}

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	if(obj.mc){
		obj.mc.removeMovieClip();
		obj.mc = null;
	}

	HelmetRemoveExec(obj);
}

/* --------------------------------------------------------------
	Gjs
 -------------------------------------------------------------- */
function HelmetRemoveExec(obj){
	obj.exec = HelmetStayExec;
}


/* --------------------------------------------------------------
	GԂꏉ
 -------------------------------------------------------------- */
function HelmetStanInit(obj){
	obj.exec = HelmetStanExec;
	obj.mc.ANM_GOTO = "_crush";
	obj.spd = Vec2dCreate(0,0);
	obj.flg |= HELMET_FLG_DEC;

	if(obj.hittest){
		HittestRemove(obj.hittest);
	}
	obj.rect = HelmetStanCollisionRect;
	obj.hittest = {pos : obj.pos,rect: obj.rect,func:HelmetHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_TURTLE);
	obj.flg &= ~HELMET_FLG_PLAYER_HIT;
	obj.flg |= HELMET_FLG_STAN;

	obj.count = 0;

	HelmetStanExec(obj);
}

/* --------------------------------------------------------------
	GԂꐁя
 -------------------------------------------------------------- */
function HelmetStanBrowInit(obj){

	obj.exec = HelmetStanExec;
	obj.mc.ANM_GOTO = "_crush";
	obj.spd.y -= 4;
	obj.flg |= HELMET_FLG_DEC;

	if(obj.hittest){
		HittestRemove(obj.hittest);
	}
	obj.rect = HelmetStanCollisionRect;
	obj.hittest = {pos : obj.pos,rect: obj.rect,func:HelmetHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_TURTLE);
	obj.flg &= ~HELMET_FLG_PLAYER_HIT;
	obj.flg |= HELMET_FLG_STAN;

	obj.count = 0;

	HelmetStanExec(obj);
}



/* --------------------------------------------------------------
	GԂs
 -------------------------------------------------------------- */
function HelmetStanExec(obj){
	if(++obj.count == 10){
		obj.flg |= HELMET_FLG_PLAYER_HIT;
	}
	
	if(obj.count == 270){
		obj.mc.ANM_GOTO = "_recover";
	}
	if( obj.count > 300){
		obj.spd.y = -2;
		obj.exec = HelmetMoveInit;
	
	}

	obj.spd.y += HELMET_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

}

/* --------------------------------------------------------------
	ObN
 -------------------------------------------------------------- */
function HelmetRock(obj){
	HelmetRockInit(obj);
}

/* --------------------------------------------------------------
	ObNJ
 -------------------------------------------------------------- */
function HelmetUnRock(obj){
	// ߂荞ł̂ŎS
	if(HelmetWallCheck(obj)){
		obj.flg |= HELMET_FLG_COLLISION;
		HelmetTurtleInit(obj);
		SePlay(SE_CLUSH,obj.pos);
	}else{
		if(obj.dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else				obj.mc.ANM_GOTO = "_rotate_l";
		HelmetBlowInit(obj);
	}
}

/* --------------------------------------------------------------
	bN
 -------------------------------------------------------------- */
function HelmetRockInit(obj){

	obj.exec = HelmetRockExec;
	obj.mc.ANM_GOTO = "_crush";
	obj.spd = Vec2dCreate(0,0);
	obj.flg &= ~HELMET_FLG_COLLISION;
	obj.flg &= ~HELMET_FLG_PLAYER_HIT;

	obj.count = 0;

	HelmetRockExec(obj);
}


/* --------------------------------------------------------------
	GԂs
 -------------------------------------------------------------- */
function HelmetRockExec(obj){
	// GU
	if(HelmetHaveAttackCheck(obj)){
		if(obj.dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else				obj.mc.ANM_GOTO = "_rotate_l";
		HelmetBlowInit(obj);
		
		// vC[̃bNO
		if(PLAYER_TASK.obj.have){
			PLAYER_TASK.obj.have = null;
		}
	}else{
		// fbhbN
		if(++obj.count > 3){
			obj.flg |= HELMET_FLG_COLLISION;
			HelmetStanInit(obj);
		}
	}
	
	obj.hittest.pos = obj.pos;

}

/* --------------------------------------------------------------
	ړ
 -------------------------------------------------------------- */
function HelmetTurtleInit(obj){

	obj.exec = HelmetTurtleExec;
	obj.mc.ANM_GOTO = "_crush";
	obj.flg &= ~HELMET_FLG_DEC;

	obj.spd_max = HELMET_TURTLE_SPD;
	obj.spd.x = obj.spd_max * obj.dir;
	obj.beat = 0;

	obj.rect = HelmetStanCollisionRect;

	if(obj.hittest){
		HittestRemove(obj.hittest);
	}
	obj.hittest = {pos : obj.pos,rect: obj.rect,func:HelmetHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_TURTLE_ATT);
	obj.flg &= ~HELMET_FLG_STAN;
	obj.flg &= ~HELMET_FLG_PLAYER_HIT;


	obj.count = 0;

	HelmetTurtleExec(obj);
}


/* --------------------------------------------------------------
	GԂs
 -------------------------------------------------------------- */
function HelmetTurtleExec(obj){

	obj.count ++;

	if(obj.count == 10){
		obj.flg |= HELMET_FLG_PLAYER_HIT;
	}

	if(obj.count > 20){
		HelmetAttackCheck(obj);
	}
	HelmetEnAttackCheck(obj);

	obj.spd.y += HELMET_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	// Xe[W
	HelmetStageCollisoinCheck(obj);

}


/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function HelmetBlowInit(obj){

	// vC[̃bNO
	if(PLAYER_TASK.obj.have == obj){
		PLAYER_TASK.obj.have = null;
	}

	if(obj.depth){
		FreeDepthPurge(obj.depth);
	}
	// [x`FW
	obj.depth = EffectDepthGet();
	obj.mc.swapDepths(obj.depth.depth);

	obj.exec = HelmetBlowExec;
	obj.spd.y = -5;
	if(obj.id != -1)	STAGE_SCRIPT_WORK[obj.id] = false;
	


	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	obj.count = 0;

	obj.flg &= ~HELMET_FLG_COLLISION;
	SePlay(SE_CLUSH,obj.pos);

	HelmetBlowExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function HelmetBlowExec(obj){
	obj.spd.y += HELMET_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);

	if(++obj.count > 120){
		TaskDelete(obj.task);
		return;
	}
}


/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function HelmetMoveInit(obj){
	obj.mc.ANM_GOTO = "_normal"
	obj.exec = HelmetMoveExec;
	obj.flg &= ~HELMET_FLG_DEC;
	obj.spd_max = HELMET_MOVE_SPD;
	obj.spd.x = obj.spd_max * obj.dir;

	HelmetMoveExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function HelmetMoveExec(obj){
	HelmetAttackCheck(obj);
	
	if(HelmetNextCheck(obj)){
		obj.dir *= -1;
		obj.spd.x = obj.spd_max * obj.dir;	
	}
	
	obj.spd.y += HELMET_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;
}


/* --------------------------------------------------------------
	n`Փ˃`FbN
 -------------------------------------------------------------- */
/*
function HelmetCollisionCheck(obj){
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = obj.rect;


	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 20) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;

	var PL_Y_LENGTH = 0;
	

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH + 2;
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y >= 0){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								var y = t2 - rect.y - rect.h;  // ɕ␳
								if(vec.y > y)	vec.y = y;

								check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
								
								vec.y += data.param.spd.y;
//								vec = Vec2dAdd(vec,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y >= 0){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							var y = t2 - rect.y - rect.h;  // ɕ␳
							if(vec.y > y)	vec.y = y;

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}else{
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							var y = m2 - rect.y; 			// ɕ␳
							if(vec.y < y)	vec.y = y;

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							check3 = true;
						}
					}
					
					// xf
					vec.y += data.param.spd.y;
					PL_Y_LENGTH += Math.abs(data.param.spd.y);
//					vec = Vec2dAdd(vec,data.param.spd);
					
				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	var l1 = rect.x + vec.x;
	var t1 = rect.y + vec.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x > 0){
						// ubN̍[
						if(r1 - l2 <= MAX_X_LENGTH){
							var x = l2 - rect.x - rect.w;  // ɕ␳
							if(vec.x > x)	vec.x = x;

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							obj.dir *= -1;
							spd.x = obj.spd_max * obj.dir;
						}

					// Ɉړ
					}else{
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){
							var x = r2 - rect.x;  // Eɕ␳
							if(vec.x < x)	vec.x = x;

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
							obj.dir *= -1;
							spd.x = obj.spd_max * obj.dir;
						}
					}

					// xf
//					vec.x += data.param.spd.x;
//					vec = Vec2dAdd(vec,data.param.spd);

				}

				data = data.post;
			}
		}
	}


	pos.x = vec.x;


	if(check2){

		return false;
	
	}else{
		pos.y = vec.y;
		if(check3){
			spd.y = 0;
		}
	}
	
	return check;
}
*/

// n``FbN
function HelmetCollisionCheck(obj){
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = obj.rect;

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 10) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var t3 = 0x7FFFFFFF;
	var m3 =-0x7FFFFFFF;
	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;
	
	var speed = Vec2dCreate(0,0);

	var PL_Y_LENGTH = 1;
	
	
	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y);
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;
				
				if(r1 < l2){
				}else if(r2 < l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{

					if(t2 < t3)	t3 = t2;
					if(m2 > m3)	m3 = m2;
					
					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}
					}

				}

				data = data.post;
			}
		}
	}

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							
							if(m1 - t2 < MAX_Y_LENGTH){

								speed.y +=  data.param.spd.y;

								var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
								if(vec.y > y){
									vec.y = y;
									if(!data.param.spd.y){
										speed.y = 0;
									}
								}

								if(spd.y > 0)	check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;

								// `Abvf[g
								l1 = rect.x + vec.x;
								t1 = rect.y + vec.y;
								r1 = l1 + rect.w;
								m1 = t1 + rect.h;
								
//								vec = Vec2dAdd(vec,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
							if(vec.y > y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							
						}
					}

					// Ɉړ
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = m2 - rect.y + 0.001; 			// ɕ␳
							if(vec.y < y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;


						}
					}

					PL_Y_LENGTH += Math.abs(data.param.spd.y);
					//vec = Vec2dAdd(vec,data.param.spd);
					//speed = Vec2dAdd( speed , data.param.spd);

					// `Abvf[g
					l1 = rect.x + vec.x;
					t1 = rect.y + vec.y;
					r1 = l1 + rect.w;
					m1 = t1 + rect.h;

				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	l1 = rect.x + vec.x;
	t1 = rect.y + vec.y;
	r1 = l1 + rect.w;
	m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x - Math.abs(data.param.spd.x) >= -0.001){
						// ubN̍[
						
						if(r1 - l2 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = l2 - rect.x - rect.w - 0.001;  // ɕ␳
							if(vec.x > x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							
						}
					}

					// Ɉړ
					if(spd.x - Math.abs(data.param.spd.x) <= 0.001){
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = r2 - rect.x + 0.001;  // Eɕ␳
							if(vec.x < x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;

						}
					}
				}

				data = data.post;
			}
		}
	}

	vec = Vec2dAdd(speed,vec);
	pos.x = vec.x;


	// ǐڐG
	if(check4){
		obj.dir = ((check4 == 1) ? -1 : 1);
		spd.x = obj.spd_max * obj.dir;
		
		// ǏՓˌʉ
		if(obj.spd_max >= HELMET_TURTLE_SPD){
			SePlay(SE_BLOCK,obj.pos);
		}
	}

	// ǖ
	if(check2){
		return false;
	}
	
	
	pos.y = vec.y;

	// V
	if(check3){
		spd.y = 0;
	}

	return check;
}


/* --------------------------------------------------------------
	炢֐
 -------------------------------------------------------------- */
function HelmetHitTestFunc(obj,type,pos,spd){

	switch(type){
	case HITTEST_TYPE_PLAYER:
		if(!(obj.flg & HELMET_FLG_PLAYER_HIT)){
			return false;
		}else if(obj.flg & HELMET_FLG_STAN){
			obj.dir = MathSign(obj.pos.x - pos.x);
			HelmetTurtleInit(obj);
//			obj.exec = HelmetTurtleInit;
		}else{
			obj.dir = MathSign(obj.pos.x - pos.x);
			HelmetStanInit(obj);
//			obj.exec = HelmetStanInit;
		}
		break;
	case HITTEST_TYPE_PLAYER_ITEM:
		var dir = MathSign(spd.x);
		obj.spd.x = MathSign(spd.x) * obj.spd_max;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		HelmetBlowInit(obj);
		break;
	case HITTEST_TYPE_TURTLE_ATT:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * obj.spd_max;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		HelmetBlowInit(obj);
		break;
	case HITTEST_TYPE_STAGE:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * obj.spd_max;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		HelmetStanBrowInit(obj);
		break;
	case HITTEST_TYPE_STAR:
	case HITTEST_TYPE_STAGE_KILL:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * obj.spd_max;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		HelmetBlowInit(obj);
		break;
	case HITTEST_TYPE_BOSS:
		if(obj.flg & HELMET_FLG_STAN){
			obj.dir = MathSign(obj.pos.x - pos.x);
			obj.exec = HelmetTurtleInit;
//			HelmetTurtleInit(obj);
		}
		break;
	}
	
	return true;
}





/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function HelmetAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_ENEMY);
		}

		data = list;
	}
}

/* --------------------------------------------------------------
	Gւ̍U`FbN
 -------------------------------------------------------------- */
function HelmetEnAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_ENEMY].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT,obj.pos,obj.spd);
				var score = FootAttackScore[obj.beat];
				if( ++ obj.beat > 7)	obj.beat = 7;
				ScoreSCreate(obj.task,{pos : data.param.pos,score : score});
			}
		}

		data = list;
	}

	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;
		
		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT,obj.pos,obj.spd);
				var score = FootAttackScore[obj.beat];
				if( ++ obj.beat > 7)	obj.beat = 7;
				ScoreSCreate(obj.task,{pos : data.param.pos,score : score});
			}
		}

		data = list;
	}

	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE_ATT].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;
		
		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT,obj.pos,obj.spd);
				obj.dir = MathSign(obj.pos.x - b_pos.x);
				// т
				if(obj.dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
				else				obj.mc.ANM_GOTO = "_rotate_l";
				obj.spd.x = dir * obj.spd_max;
				HelmetBlowInit(obj);
				return;
			}
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_BOSS].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;
		
		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT,obj.pos,obj.spd);
				obj.dir = MathSign(obj.pos.x - b_pos.x);
				// т
				if(obj.dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
				else				obj.mc.ANM_GOTO = "_rotate_l";
				obj.spd.x = dir * obj.spd_max;
				HelmetBlowInit(obj);
				return;
			}
		}

		data = list;
	}
}



/* --------------------------------------------------------------
	̍U
 -------------------------------------------------------------- */
function HelmetHaveAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_ENEMY].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT);
				return true;
			}
		}

		data = list;
	}

	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;
		
		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT);
				return true;
			}
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE_ATT].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;
		
		if(obj != data.param){

			var b_rect = data.rect;
			var b_pos  = data.pos;

			var l2 = b_rect.x + b_pos.x;
			var t2 = b_rect.y + b_pos.y;
			var r2 = l2 + b_rect.w;
			var m2 = t2 + b_rect.h;

			if(r1 < l2){
			}else if(r2 < l1){
			}else if(m1 < t2){
			}else if(m2 < t1){
			}else{
				data.func(data.param,HITTEST_TYPE_TURTLE_ATT);
				return true;
			}
		}

		data = list;
	}
	
	return false;
}


// Xe[Wɑ΂čU
function HelmetStageCollisoinCheck(obj){
	var pos = obj.pos;
	var rect = HelmetStageCollisionRect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_STAGE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 <= l2){
		}else if(r2 <= l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_TURTLE_ATT,obj.pos);
			obj.dir *= -1;
			obj.spd.x = obj.spd_max * obj.dir;
			return;
		}

//		data = data.post;
		data = list;
	}
}

// ߂荞݃`FbN
function HelmetWallCheck(obj){
	
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 20) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{					
					return false;
				}

				data = data.post;
			}
		}
	}
	return true;
}


// R`FbN
function HelmetNextCheck(obj){
	
	var pos = obj.pos;
	var spd = obj.spd;

	var l1 = 10 * obj.dir + pos.x;
	var t1 = 10 + pos.y;
	var r1 = l1 + 1;
	var m1 = t1 + 1;

	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 10) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{
					return false;
				}

				data = data.post;
			}
		}
	}
	return true;
}
