/* -----------------------------------------------------------------------------
	^CL֐
	t@C  : tiyaki.as
			: hakuhin (c) 2006/12/08
	
			: ^CLp֐
 ----------------------------------------------------------------------------- */

TAIYAKI_WIDTH  = 18;
TAIYAKI_HEIGHT = 18;
TAIYAKI_RADIUS = TAIYAKI_WIDTH / 2;
TAIYAKI_MOVE_SPD      = 1.5;


TaiyakiCollisionRect = {
	x : -TAIYAKI_RADIUS,
	y : -TAIYAKI_RADIUS,
	w :  TAIYAKI_WIDTH,
	h :  TAIYAKI_HEIGHT
};




/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function TaiyakiTaskCreate(task,param){
	return TaskCreate(
		TaiyakiInitalize,
		TaiyakiExecute,
		TaiyakiDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function TaiyakiInitalize(obj,task,param){
	obj.task = task;

	obj.depth = EnemyDepthGet();
	obj.mc = _root.sprite.attachMovie("taiyaki","_" + obj.depth.depth, obj.depth.depth);
	obj.mc._xscale = -100 * param.dir;
	
	AnmCmdInit(obj.mc);
	obj.mc.ANM_GOTO = "_stand";

	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(TAIYAKI_MOVE_SPD * param.dir , 0);
	obj.rect = TaiyakiCollisionRect;
	obj.dir = param.dir;


	obj.hittest = {pos : obj.pos,rect: obj.rect,func:TaiyakiHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_ENEMY);

	obj.exec = TaiyakiMoveInit;
	
	TaiyakiExecute();
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function TaiyakiExecute(obj){
	obj.exec(obj);	// s

	// XN[ɓ
	var vec = ScreenPosition(obj.pos);

	var x = vec.x - GAME_WIDTH_HALF;
	var y = vec.y - GAME_HEIGHT_HALF;


	if((Math.abs(x) < 200) && (Math.abs(y) < 180)){
	}else{
		TaskDelete(obj.task);
		return;
	}
	
	if(obj.hittest)	obj.hittest.pos = obj.pos;

	
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
	
	AnmCmdPlay(obj.mc);
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function TaiyakiDelete(obj){
	if(obj.depth){
		FreeDepthPurge(obj.depth);
		obj.depth = null;
	}

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	
	obj.mc.removeMovieClip();
	obj.mc = null;

}



/* --------------------------------------------------------------
	Gя
 -------------------------------------------------------------- */
function TaiyakiBlowInit(obj){
	if(obj.depth){
		FreeDepthPurge(obj.depth);
	}
	// [x`FW
	obj.depth = EffectDepthGet();
	obj.mc.swapDepths(obj.depth.depth);

	obj.exec = TaiyakiBlowExec;
	obj.spd.y = -5;
	STAGE_SCRIPT_WORK[obj.id] = false;


	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.count = 0;
	SePlay(SE_CLUSH,obj.pos);

	TaiyakiBlowExec(obj);
}


/* --------------------------------------------------------------
	Gюs
 -------------------------------------------------------------- */
function TaiyakiBlowExec(obj){
	obj.spd.y += PLAYER_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);

	if(++obj.count > 120){
		TaskDelete(obj.task);
		return;
	}
}



/* --------------------------------------------------------------
	Gړ
 -------------------------------------------------------------- */
function TaiyakiMoveInit(obj){
	obj.exec = TaiyakiMoveExec;
	
	obj.smoke_count = 0;

	TaiyakiMoveExec(obj);
}


/* --------------------------------------------------------------
	Gړs
 -------------------------------------------------------------- */
function TaiyakiMoveExec(obj){
	TaiyakiAttackCheck(obj);
	
	if(++obj.smoke_count > 3){
		obj.smoke_count = 0;
		EffectSpriteCreate(obj.task,{pos:{ x : obj.pos.x + obj.dir * -10, y : obj.pos.y },asset:"smoke"});
	}
	
	obj.pos = Vec2dAdd(obj.pos,obj.spd);

}


/* --------------------------------------------------------------
	炢֐
 -------------------------------------------------------------- */
function TaiyakiHitTestFunc(obj,type,pos,spd){

	switch(type){
	case HITTEST_TYPE_PLAYER:
		obj.spd.x = 0;
		obj.spd.y = 0;
		TaiyakiBlowInit(obj);
		break;
	case HITTEST_TYPE_PLAYER_ITEM:
		return false;
	case HITTEST_TYPE_STAGE:
	case HITTEST_TYPE_TURTLE_ATT:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * MUSHROOM_MOVE_SPD;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		TaiyakiBlowInit(obj);
		
	case HITTEST_TYPE_STAR:
	case HITTEST_TYPE_STAGE_KILL:
		var dir = MathSign(obj.pos.x - pos.x);
		obj.spd.x = dir * MUSHROOM_MOVE_SPD;
		if(dir == 1)	obj.mc.ANM_GOTO = "_rotate_r";
		else			obj.mc.ANM_GOTO = "_rotate_l";
		TaiyakiBlowInit(obj);
		break;
	}
	
	return true;
}


/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function TaiyakiAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_ENEMY,obj.pos,obj.spd);
		}

		data = list;
	}
}
