/* -----------------------------------------------------------------------------
	t[֐
	t@C  : mashroom.as
			: hakuhin (c) 2006/11/08
	
			: t[p֐
 ----------------------------------------------------------------------------- */

FLOWER_WIDTH = 20;
FLOWER_HEIGHT = FLOWER_WIDTH;
FLOWER_RADIUS = FLOWER_WIDTH / 2;
FLOWER_APPEAR_SPD = 0.25;
FLOWER_MOVE_SPD = 0.0;
FLOWER_JUMP_POW= 6.0;	// Wv


FlowerCollisionRect = {
		x : -FLOWER_RADIUS + 5,
		y : -FLOWER_RADIUS,
		w :  FLOWER_WIDTH  - 10,
		h :  FLOWER_HEIGHT
	};


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function FlowerTaskCreate(task,param){
	return TaskCreate(
		FlowerInitalize,
		FlowerExecute,
		FlowerDelete,
		task,PRIO_STAGE,LEVEL_PLAYER,param
	);
}


function FlowerInitalize(obj,task,param){
	obj.task = task;
	obj.depth = EnemyDepthGet();
    obj.mc = _root.sprite.attachMovie("flower","_" + obj.depth.depth, obj.depth.depth);
	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.id = param.id;

	obj.exec = FlowerAppearInit;
}


function FlowerExecute(obj){
	obj.exec(obj);	// s

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


function FlowerAppearInit(obj){
	obj.exec = FlowerAppearExec;
	obj.spd.y = -FLOWER_APPEAR_SPD;
	obj.count = 0;


	FlowerAppearExec(obj);
}


function FlowerAppearExec(obj){
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	if( ++obj.count > FLOWER_RADIUS / FLOWER_APPEAR_SPD){
		obj.exec = FlowerMoveInit;
		obj.spd.y = 0;
		obj.spd.x = RandomSign() * FLOWER_MOVE_SPD;
	}
}


function FlowerJumpInit(obj){
	obj.exec = FlowerMoveExec;
	obj.spd.y = -FLOWER_JUMP_POW;

	FlowerMoveExec(obj);
}


function FlowerMoveInit(obj){
	obj.exec = FlowerMoveExec;
	obj.count = 0;

	var rect = {
		x : -FLOWER_RADIUS,
		y : -FLOWER_RADIUS,
		w :  FLOWER_WIDTH,
		h :  FLOWER_HEIGHT
	};
	obj.hittest = {pos : obj.pos,rect: rect,func:FlowerHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_ITEM);

	FlowerMoveExec(obj);
}


function FlowerMoveExec(obj){
	obj.spd.y += PLAYER_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(FlowerCollisionCheck(obj)){
		obj.spd.y = 0;
	}
	
	ColorExecute(obj.color);

}



function FlowerDelete(obj){
	EnemyDepthPurge(obj.depth);

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.mc.removeMovieClip();
	STAGE_SCRIPT_WORK[obj.id] = false;
}


function FlowerAttachScript(param,id,task){
	FlowerTaskCreate(task,{
		pos : param.pos,
		id  : id
	});
}



// n``FbN
function FlowerCollisionCheck(obj){
	
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = FlowerCollisionRect;
	

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor(pos.y / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;

	var MAX_LENGTH = 6.0;
	

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y >= 0){
							// ubN̏[
							if(m1 - t2 < MAX_LENGTH){
								vec.y = t2 - rect.y - rect.h;  // ɕ␳
								check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
								
								obj.pos = Vec2dAdd(obj.pos,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y >= 0){
						// ubN̏[
						if(m1 - t2 < MAX_LENGTH){
							vec.y = t2 - rect.y - rect.h;  // ɕ␳

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check = true;
						}

					// Ɉړ
					}else{
						// ubN̉[
						if(m2 - t1 < MAX_LENGTH){
							vec.y = m2 - rect.y;              // ɕ␳

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;
						}
					}
				}
				
				// xf
				vec = Vec2dAdd(vec,data.param.spd);

				data = data.post;
			}
		}
	}

	// `Abvf[g
	var l1 = rect.x + vec.x;
	var t1 = rect.y + vec.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					// EɈړ
					if(spd.x > 0){
						// ubN̍[
						if(r1 - l2 <= MAX_LENGTH){
							vec.x = l2 - rect.x - rect.w;  // ɕ␳
							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							spd.x *= -1;
						}

					// Ɉړ
					}else{
						// ubN̉E[
						if(r2 - l1 <= MAX_LENGTH){
							vec.x = r2 - rect.x;              // Eɕ␳
							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
							spd.x *= -1;
						}
					}
				}

				data = data.post;
			}
		}
	}


	pos.x = vec.x;


	if(check2){

		return false;
	
	}else{
		pos.y = vec.y;
		if(check3){
			spd.y = 0;
		}
	}
	
	return check;
}



function FlowerHitTestFunc(obj,type,pos){
	var dir = MathSign(obj.pos.x - pos.x);
	obj.spd.x = dir * FLOWER_MOVE_SPD;

	switch(type){
	case HITTEST_TYPE_PLAYER:
		FlowerHitPlayerCheck(obj);
		break;
	case HITTEST_TYPE_STAGE:
		FlowerJumpInit(obj);
		break;
	}
}


// t[`FbN
function FlowerHitPlayerCheck(obj){
	ScoreSCreate(null,{pos : obj.pos,score : 1000});
	
	PopupMsgSet("flower_get");
	PlayerPowerUpFunc();
	TaskDelete(obj.task);
}