/* -----------------------------------------------------------------------------
	Pto֐
	t@C  : mashroom.as
			: hakuhin (c) 2006/11/08
	
			: Ptop֐
 ----------------------------------------------------------------------------- */

ONEUP_WIDTH = 20;
ONEUP_HEIGHT = ONEUP_WIDTH;
ONEUP_RADIUS = ONEUP_WIDTH / 2;
ONEUP_APPEAR_SPD = 0.25;
ONEUP_MOVE_SPD = 2.0;
ONEUP_JUMP_POW= 6.0;	// Wv


OneupCollisionRect = {
		x : -ONEUP_RADIUS + 5,
		y : -ONEUP_RADIUS,
		w :  ONEUP_WIDTH  - 10,
		h :  ONEUP_HEIGHT
	};


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function OneupTaskCreate(task,param){
	return TaskCreate(
		OneupInitalize,
		OneupExecute,
		OneupDelete,
		task,PRIO_STAGE,LEVEL_PLAYER,param
	);
}


function OneupInitalize(obj,task,param){
	obj.task = task;
	obj.depth = EnemyDepthGet();
    obj.mc = _root.sprite.attachMovie("oneup","_" + obj.depth.depth, obj.depth.depth);
	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.id = param.id;

	obj.exec = OneupAppearInit;
}


function OneupExecute(obj){
	obj.exec(obj);	// s

	if(StageEndPos(obj)){
		obj.spd.x *= -1;
	}

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


function OneupAppearInit(obj){
	obj.exec = OneupAppearExec;
	obj.spd.y = -ONEUP_APPEAR_SPD;
	obj.count = 0;


	OneupAppearExec(obj);
}


function OneupAppearExec(obj){
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	if( ++obj.count > ONEUP_RADIUS / ONEUP_APPEAR_SPD){
		obj.exec = OneupMoveInit;
		obj.spd.y = 0;
		obj.spd.x = RandomSign() * ONEUP_MOVE_SPD;
	}
}


function OneupJumpInit(obj){
	obj.exec = OneupMoveExec;
	obj.spd.y = -ONEUP_JUMP_POW;

	OneupMoveExec(obj);
}


function OneupMoveInit(obj){
	obj.exec = OneupMoveExec;
	obj.count = 0;

	var rect = {
		x : -ONEUP_RADIUS,
		y : -ONEUP_RADIUS,
		w :  ONEUP_WIDTH,
		h :  ONEUP_HEIGHT
	};
	obj.hittest = {pos : obj.pos,rect: rect,func:OneupHitTestFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_ITEM);

	OneupMoveExec(obj);
}


function OneupMoveExec(obj){
	obj.spd.y += PLAYER_G;
	if(obj.spd.y > NORMAL_JUMP_MAX)
		obj.spd.y = NORMAL_JUMP_MAX;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	obj.hittest.pos = obj.pos;

	if(OneupCollisionCheck(obj)){
		obj.spd.y = 0;
	}
	
	ColorExecute(obj.color);

}



function OneupDelete(obj){
	EnemyDepthPurge(obj.depth);

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.mc.removeMovieClip();
	STAGE_SCRIPT_WORK[obj.id] = false;
}


function OneupAttachScript(param,id,task){
	OneupTaskCreate(task,{
		pos : param.pos,
		id  : id
	});
}



// n``FbN
/*
function OneupCollisionCheck(obj){
	
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = OneupCollisionRect;
	

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor(pos.y / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;

	var MAX_LENGTH = 6.0;
	

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y >= 0){
							// ubN̏[
							if(m1 - t2 < MAX_LENGTH){
								vec.y = t2 - rect.y - rect.h;  // ɕ␳
								check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
								
								obj.pos = Vec2dAdd(obj.pos,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y >= 0){
						// ubN̏[
						if(m1 - t2 < MAX_LENGTH){
							vec.y = t2 - rect.y - rect.h;  // ɕ␳

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check = true;
						}

					// Ɉړ
					}else{
						// ubN̉[
						if(m2 - t1 < MAX_LENGTH){
							vec.y = m2 - rect.y;              // ɕ␳

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;
						}
					}
				}
				
				// xf
				vec = Vec2dAdd(vec,data.param.spd);

				data = data.post;
			}
		}
	}

	// `Abvf[g
	var l1 = rect.x + vec.x;
	var t1 = rect.y + vec.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					// EɈړ
					if(spd.x > 0){
						// ubN̍[
						if(r1 - l2 <= MAX_LENGTH){
							vec.x = l2 - rect.x - rect.w;  // ɕ␳
							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							spd.x *= -1;
						}

					// Ɉړ
					}else{
						// ubN̉E[
						if(r2 - l1 <= MAX_LENGTH){
							vec.x = r2 - rect.x;              // Eɕ␳
							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
							spd.x *= -1;
						}
					}
				}

				data = data.post;
			}
		}
	}


	pos.x = vec.x;


	if(check2){

		return false;
	
	}else{
		pos.y = vec.y;
		if(check3){
			spd.y = 0;
		}
	}
	
	return check;
}
*/

// n``FbN
function OneupCollisionCheck(obj){
	
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = OneupCollisionRect;

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 20) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var t3 = 0x7FFFFFFF;
	var m3 =-0x7FFFFFFF;
	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;
	
	var speed = Vec2dCreate(0,0);

	var PL_Y_LENGTH = 2;
	
	
	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH + 2;
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;
				
				if(r1 < l2){
				}else if(r2 < l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{

					if(t2 < t3)	t3 = t2;
					if(m2 > m3)	m3 = m2;
					
					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}
					}

				}

				data = data.post;
			}
		}
	}

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							
							if(m1 - t2 < MAX_Y_LENGTH){

								speed.y +=  data.param.spd.y;

								var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
								if(vec.y > y){
									vec.y = y;
									if(!data.param.spd.y){
										speed.y = 0;
									}
								}

								if(spd.y > 0)	check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;

								// `Abvf[g
								l1 = rect.x + vec.x;
								t1 = rect.y + vec.y;
								r1 = l1 + rect.w;
								m1 = t1 + rect.h;
								
//								vec = Vec2dAdd(vec,data.param.spd);
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
							if(vec.y > y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							
						}
					}

					// Ɉړ
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = m2 - rect.y + 0.001; 			// ɕ␳
							if(vec.y < y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;


						}
					}

					PL_Y_LENGTH += Math.abs(data.param.spd.y);
					//vec = Vec2dAdd(vec,data.param.spd);
					//speed = Vec2dAdd( speed , data.param.spd);

					// `Abvf[g
					l1 = rect.x + vec.x;
					t1 = rect.y + vec.y;
					r1 = l1 + rect.w;
					m1 = t1 + rect.h;

				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	l1 = rect.x + vec.x;
	t1 = rect.y + vec.y;
	r1 = l1 + rect.w;
	m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x - Math.abs(data.param.spd.x) >= -0.001){
						// ubN̍[
						
						if(r1 - l2 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = l2 - rect.x - rect.w - 0.001;  // ɕ␳
							if(vec.x > x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							
						}
					}

					// Ɉړ
					if(spd.x - Math.abs(data.param.spd.x) <= 0.001){
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = r2 - rect.x + 0.001;  // Eɕ␳
							if(vec.x < x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
						}
					}
				}

				data = data.post;
			}
		}
	}

	vec = Vec2dAdd(speed,vec);
	pos.x = vec.x;


	// ǐڐG
	if(check4){
		obj.dir = ((check4 == 1) ? -1 : 1);
		spd.x = MUSHROOM_MOVE_SPD * obj.dir;

	}

	// ǖ
	if(check2){
		return false;
	}
	
	
	pos.y = vec.y;

	// V
	if(check3){
		spd.y = 0;
	}

	// n
	if(check){
	}
	
	return check;
}


function OneupHitTestFunc(obj,type,pos){
	var dir = MathSign(obj.pos.x - pos.x);
	obj.spd.x = dir * ONEUP_MOVE_SPD;

	switch(type){
	case HITTEST_TYPE_PLAYER:
		OneupHitPlayerCheck(obj);
		break;
	case HITTEST_TYPE_STAGE:
		OneupJumpInit(obj);
		break;
	}
}


// LmR`FbN
function OneupHitPlayerCheck(obj){
	ScoreSCreate(null,{pos : obj.pos,score : -1});
	TaskDelete(obj.task);
}