/* -----------------------------------------------------------------------------
	pl֐
	t@C  : arrow_panel.as
			: hakuhin (c) 2006/12/19
	
			: plp֐
 ----------------------------------------------------------------------------- */


ARROW_PANEL_TYPE_RIGHT	= 0;	// Epl
ARROW_PANEL_TYPE_DOWN	= 1;	// pl
ARROW_PANEL_TYPE_LEFT	= 2;	// pl
ARROW_PANEL_TYPE_UP		= 3;	// pl

ARROW_PANEL_SPEED_ADD	= 0.25;	// Epl


ArrowColRect = {
	x : -10,
	y : -10,
	w :  20,
	h :  20
}

/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function ArrowPanelTaskCreate(task,param){
	return TaskCreate(
		ArrowPanelInitalize,
		ArrowPanelExecute,
		ArrowPanelDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);

}

function ArrowPanelInitalize(obj,task,param){

	obj.task = task;
	obj.type = param.type;
	
	obj.pos = param.pos;
	obj.spd = Vec2dCreate(0,0);

	obj.depth = BlockDepthGet();
	obj.mc = _root.sprite.attachMovie("arrow","_" + obj.depth.depth, obj.depth.depth);
	obj.mc._x = obj.pos.x;
	obj.mc._y = obj.pos.y;

	switch(obj.type){
		case ARROW_PANEL_TYPE_UP:
			obj.vec = Vec2dCreate(0,-1);
			obj.mc._rotation = 90;
			obj.mc._xscale = -100;
			break;
		case ARROW_PANEL_TYPE_DOWN:	
			obj.vec = Vec2dCreate(0, 1);
			obj.mc._rotation = 90;
			break;
		case ARROW_PANEL_TYPE_LEFT:	
			obj.vec = Vec2dCreate(-1,0);
			obj.mc._xscale = -100;
			break;
		case ARROW_PANEL_TYPE_RIGHT:
			obj.vec = Vec2dCreate( 1,0);
			break;
	};
	
	obj.vec = Vec2dScale(obj.vec,ARROW_PANEL_SPEED_ADD);

	AnmCmdInit(obj.mc);

	// RWo^
	obj.collision = {pos : obj.pos,rect: ArrowColRect,type : COLLISION_TYPE_RECT,func : ArrowPanelCollisionHit,param : obj};
	CollisionAttach(obj.collision);
}


function ArrowPanelExecute(obj){
	AnmCmdPlay(obj.mc);
}


function ArrowPanelDelete(obj){
	BlockDepthPurge(obj.depth);

 	if(obj.collision){
		CollisionRemove(obj.collision);
		obj.collision = null;
	}
	obj.mc.removeMovieClip();
}


function ArrowPanelCollisionHit(obj){
	var spd = PLAYER_TASK.obj.spd;
	spd.x += obj.vec.x;
	spd.y += obj.vec.y;
	if(spd.x > 5)	spd.x = 5;
	if(spd.x <-5)	spd.x =-5;
	if(spd.y > 5)	spd.y = 5;
	if(spd.y <-6)	spd.y =-6;
	
	PLAYER_TASK.obj.flg |= PLAYER_FLG_WALL_OK;
}


function ArrowPanelAttachScript(param,id,task){
	ArrowPanelTaskCreate(task,{
		pos  : param.pos,
		type : param.type,
		id   : id
	});
}